(function () {
    "use strict";

    angular.module('core').controller('contatoDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$stateParams', 'contatoService', 'empresaService', 'lookupService', 'tipoClienteService', '$q'];

    function controller($scope, $timeout, $state, $stateParams, contatoService, empresaService, lookupService, tipoClienteService, $q) {
        $scope.initializeLayout('Contato');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
            tabCorrente: 0,
            tabs: {
                detalhes: 0,
                cliente: 1,
                vendedor: 2,
                fornecedor: 3,
            },
            listFuncoes: null,
            filtroTipoCliente: {
                args: {
                    chaves: '',
                    ativo: null,
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            },
            listTipoCliente: null
        };
        $scope.popups = {
            empresas: { ativo: false },
            andamentos: { ativo: false }
        };
        $scope.auxiliar = {
            filial: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(
                                function (response) {
                                    if (response.Status < 0) {
                                        $scope.tools.toastr.error(response.Message, 'Serviço');
                                    }
                                    else {
                                        angular.copy(angular.fromJson(response.Data), $scope.auxiliar.filial.data);
                                        return response.Data;
                                    }
                                }
                            )
                    );
                },
            },
            loja: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllLoja({ chaves: chaves })
                            .then(
                                function (response) {
                                    if (response.Status < 0) {
                                        $scope.tools.toastr.error(response.Message, 'Serviço');
                                    }
                                    else {
                                        angular.copy(angular.fromJson(response.Data), $scope.auxiliar.loja.data);
                                        return response.Data;
                                    }
                                }
                            )
                    );
                },
            },
            empresas: {

                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllEmpresa({ chaves: chaves })
                            .then(
                                function (response) {
                                    if (response.Status < 0) {
                                        $scope.tools.toastr.error(response.Message, 'Serviço');
                                    } else {
                                        angular.copy(angular.fromJson(response.Data), $scope.auxiliar.empresas.data);
                                        return response.Data;
                                    }
                                })

                    );
                },
            },
            estado: {
                data: [],
                args: {},
                getAll: function () {
                    lookupService
                        .getAllEstado($scope.auxiliar.estado.args)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    angular.copy(angular.fromJson(response.Data), $scope.auxiliar.estado.data);
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
            },
            vendedor: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllVendedor({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.error(response.Message, "Serviço");
                                else {
                                    angular.copy(angular.fromJson(response.Data), $scope.auxiliar.vendedor.data);
                                    return response.Data;
                                }
                            })
                    );
                },
            },
            endereco: {
                prepare: function (index) {
                    empresaService
                        .prepareEndereco($scope.state.item.Enderecos[index])
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                } else {
                                    $scope.state.item.Enderecos[index] = response.Data;
                                    $timeout(function () { $('#enderecos [ng-model$="item.Linha2"]').focus(); });
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
                prepareNew: function () {
                    empresaService
                        .prepareNewEndereco($scope.state.item)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                } else {
                                    $scope.state.item = response.Data;
                                    $timeout(function () { $('enderecos [ng-model$="item.Tipo"]').focus(); });
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
            }
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };
        $scope.save = function () {
            $scope.state.carregando = true;
            contatoService.save($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        }
                        else {
                            $scope.historyBack();
                        }
                        $scope.state.carregando = false;
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    }
                );
        };
        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;

            contatoService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
            tipoClienteService
                .getAll($scope.state.filtroTipoCliente.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.listTipoCliente = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
            empresaService
                .getAllFilial()
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.listFilial = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.get();
            $scope.auxiliar.estado.getAll();
        };

        $scope.toggleEmpresas = function () {
            $scope.popups.empresas.ativo = !$scope.popups.empresas.ativo;
            if ($scope.popups.empresas.ativo) {
                $scope.getAllEmpresa();
            }
        };
        $scope.toggleAndamentos = function () {
            $scope.popups.andamentos.ativo = !$scope.popups.andamentos.ativo;
        };

        $scope.getAllEmpresa = function () {
            $scope.auxiliar.empresas.carregando = true;
            $scope.auxiliar.empresas.vazio = false;
            empresaService
                .getAll($scope.auxiliar.empresas.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            console.error(response.Exception);
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.auxiliar.empresas.data);
                        }
                        $scope.auxiliar.empresas.carregando = false;
                        $scope.auxiliar.empresas.vazio = !response.Data.length;
                    },
                    function (_error) {
                        $scope.auxiliar.empresas.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    });
        }

        /*Inicializa funções*/
        $scope.initialize();

    }

})();